---
title: Using the Permissions API
slug: Web/API/Permissions_API/Using_the_Permissions_API
tags:
  - API
  - Experimental
  - Geolocation
  - Guide
  - Permissions
---
<p>{{DefaultAPISidebar("Permissions API")}}{{SeeCompatTable}}</p>

<p class="summary">This article provides a basic guide to using the W3C Permissions API, which provides a programmatic way to query the status of API permissions attributed to the current context.</p>

<h2 id="The_trouble_with_asking_for_permission...">The trouble with asking for permission...</h2>

<p>Let's face it, permissions on the Web are a necessary evil, and they are not much fun to deal with as developers.</p>

<p>Historically, different APIs handle their own permissions inconsistently — for example the Notifications API allows for explicit checking of permission status and requesting permission, whereas the Geolocation API doesn't (which causes problems if the user denied the initial permission request, as we'll see below).</p>

<p>The <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a> provides the tools to allow developers to implement a better user experience as far as permissions are concerned. For example, it can query whether permission to use a particular API is granted or denied, and specifically request permission to use an API.</p>

<p>At the moment, implementation of the API is at an early stage, so support in browsers is pretty spotty:</p>

<ul>
 <li>It can only be found in Chrome 44 and later and Firefox 43 and later.</li>
 <li>The only supported method right now is {{domxref("Permissions.query()")}}, which queries permission status.</li>
 <li>The only two APIs currently recognized by the Permissions API in Chrome are <a href="/en-US/docs/Web/API/Geolocation">Geolocation</a> and Notification, with Firefox also recognizing <a href="/en-US/docs/Web/API/Push_API">Push</a> and WebMIDI.</li>
</ul>

<p>More features will be added as time progresses.</p>

<h2 id="A_simple_example">A simple example</h2>

<p>For this article, we have put together a simple demo called Location Finder. It uses Geolocation to query the user's current location and plot it out on a Google Map:</p>

<p><img alt="Screenshot showing a map of Greenfield, UK." src="https://mdn.mozillademos.org/files/11501/location-finder-with-permissions-api.png" style="display: block; height: 428px; margin: 0px auto; width: 700px;"></p>

<p>You can <a href="https://chrisdavidmills.github.io/location-finder-permissions-api/">run the example live</a>, or <a href="https://github.com/chrisdavidmills/location-finder-permissions-api/tree/gh-pages">view the source code on Github</a>. Most of the code is simple and unremarkable — below we'll just be walking through the Permissions API-related code, so check the code yourself if you want to study any of the other parts.</p>

<h3 id="Accessing_the_Permissions_API">Accessing the Permissions API</h3>

<p>The {{domxref("Navigator.permissions")}} property has been added to the browser to allow access to the global {{domxref("Permissions")}} object. This object will eventually include methods for querying, requesting, and revoking permissions, although currently it only contains {{domxref("Permissions.query()")}}; see below.</p>

<h3 id="Querying_permission_state">Querying permission state</h3>

<p>In our example, the Permissions functionality is handled by one function — <code>handlePermission()</code>. This starts off by querying the permission status using {{domxref("Permissions.query()")}}. Depending on the value of the {{domxref("PermissionStatus.state", "state")}} property of the  {{domxref("PermissionStatus")}} object returned when the promise resolves, it reacts differently:</p>

<dl>
 <dt><code>"granted"</code></dt>
 <dd>The "Enable Geolocation" button is hidden, as it isn't needed if Geolocation is already active.</dd>
 <dt><code>"prompt"</code></dt>
 <dd>The "Enable Geolocation" button is hidden, as it isn't needed if the user will be prompted to grant permission for Geolocation. The {{domxref("Geolocation.getCurrentPosition()")}} function is then run, which prompts the user for permission; it runs the <code>revealPosition()</code> function if permission is granted (which shows the map), or the <code>positionDenied()</code> function if permission is denied (which makes the "Enable Geolocation" button appear).</dd>
 <dt><code>"denied"</code></dt>
 <dd>The "Enable Geolocation" button is revealed (this code needs to be here too, in case the permission state is already set to denied for this origin when the page is first loaded).</dd>
</dl>

<pre class="brush: js notranslate">function handlePermission() {
  navigator.permissions.query({name:'geolocation'}).then(function(result) {
    if (result.state == 'granted') {
      report(result.state);
      geoBtn.style.display = 'none';
    } else if (result.state == 'prompt') {
      report(result.state);
      geoBtn.style.display = 'none';
      navigator.geolocation.getCurrentPosition(revealPosition,positionDenied,geoSettings);
    } else if (result.state == 'denied') {
      report(result.state);
      geoBtn.style.display = 'inline';
    }
    result.onchange = function() {
      report(result.state);
    }
  });
}

function report(state) {
  console.log('Permission ' + state);
}

handlePermission();</pre>

<h3 id="Permission_descriptors">Permission descriptors</h3>

<p>The {{domxref("Permissions.query()")}} method takes a <code>PermissionDescriptor</code> dictionary as a parameter — this contains the name of the API you are interested in. Some APIs have more complex <code>PermissionDescriptor</code>s containing additional information, which inherit from the default <code>PermissionDescriptor</code>. For example, the <code>PushPermissionDescriptor</code> should also contain a Boolean that specifies if <code><a href="/en-US/docs/Web/API/PushManager/subscribe#Parameters">userVisibleOnly</a></code> is <code>true</code> or <code>false</code>.</p>

<h3 id="Revoking_permissions">Revoking permissions</h3>

<p>Starting in Firefox 47, you can now revoke existing permissions, using the  {{domxref("Permissions.revoke()")}} method. This works in exactly the same way as the {{domxref("Permissions.query()")}} method, except that it causes an existing permission to be reverted back to its default state when the promise successfully resolves (which is usually <code>prompt</code>). See the following code in our demo:</p>

<pre class="brush: js notranslate">var revokeBtn = document.querySelector('.revoke');

  ...

revokeBtn.onclick = function() {
  revokePermission();
}

  ...

function revokePermission() {
  navigator.permissions.revoke({name:'geolocation'}).then(function(result) {
    report(result.state);
  });
}</pre>

<div class="note">
<p>The <code>revoke()</code> function has been disabled by default starting in Firefox 51, since its design has been brought into question in the <a href="https://www.w3.org/2011/webappsec/">Web Applications Security Working Group</a>. It can be re-enabled by setting the preference <code>dom.permissions.revoke.enable</code> to <code>true</code>.</p>
</div>

<h3 id="Responding_to_permission_state_changes">Responding to permission state changes</h3>

<p>You'll notice that there is an <code>onchange</code> event handler in the code above, attached to the {{domxref("PermissionStatus")}} object — this allows us to respond to any changes in the permission status for the API we are interested in. At the moment we are just reporting the change in state.</p>

<h2 id="Conclusion_and_future_work">Conclusion and future work</h2>

<p>At the moment this doesn't offer much more than what we had already. If we choose to never share our location from the permission prompt (deny permission), then we can't get back to the permission prompt without using the browser menu options:</p>

<ul>
 <li><strong>Firefox</strong>: <em>Tools &gt; Page Info &gt; Permissions &gt; Access Your Location</em>. Select <em>Always Ask</em>.</li>
 <li><strong>Chrome</strong>: <em>Hamburger Menu &gt; Settings &gt; Show advanced settings</em>. In the <em>Privacy</em> section, click <em>Content Settings</em>. In the resulting dialog, find the <em>Location</em> section and select <em>Ask when a site tries to...</em> . Finally, click <em>Manage Exceptions</em> and remove the permissions you granted to the sites you are interested in.</li>
</ul>

<p>However, future additions to browser functionality should provide the <code>request()</code> method, which will allow us to programatically request permissions, any time we like. These should hopefully be available soon.</p>
